from ngsolve import *
from netgen.geom2d import unit_square
mesh = Mesh(unit_square.GenerateMesh(maxh=0.1))

fesL2 = L2(mesh, order=1)
MatrixL2 = FESpace( [fesL2,fesL2,fesL2] )
(uxx,uxy,uyy),(vxx,vxy,vyy) = MatrixL2.TnT()

um = CoefficientFunction( (uxx, uxy,
                           uxy, uyy), dims=(2,2))
vm = CoefficientFunction( (vxx, vxy,
                           vxy, vyy), dims=(2,2))

a = BilinearForm(MatrixL2)
a += InnerProduct(um,vm)*dx
a.Assemble()

f = LinearForm(MatrixL2)
f += InnerProduct(CoefficientFunction( (1,2,3,4), dims=(2,2) ),vm)*dx
f.Assemble()


gf = GridFunction(MatrixL2)
gf.vec.data = a.mat.Inverse(MatrixL2.FreeDofs())*f.vec

gfm = CoefficientFunction( (gf.components[0],gf.components[1],
                            gf.components[1],gf.components[2]), dims=(2,2) )
Draw(gfm,mesh,"gfm")
Draw(Norm(gfm),mesh,"norm_gfm")
